## API Review Notes for September 30th, 2019

### Changes reviewed
Starting commit: `12b125030c34e340086b7fa192fb9426aaddf054`

Ending Commit: `38c90f8401f9e3ee5fb7c82aac36f6b85fdda979`

### Notes

For the AnalyzerConfig removals, we've said that we're fine with this change because the API was just published, and wasn't intended to be.
We don't want to maintain the API shape in the future, and we're willing to accept the risk of breaks in order to remove it now, before many people can take a hard dependency on the API surface.

ErrorLogPath removed from CommandLineArguments, moved to ErrorLogOptions.Path
 - We should maintain this API.
 - Just forward to the old implementation.
 - @333fred will send a PR.

TextDocument
 - Should we not remove the constructor? This is a binary breaking change
 - This empty constructor cannot be used.
 - We'll keep the change.

Workspace
 - CanApplyParseOptionChange going from virtual protected to virtual public is a source and binary breaking change
 - We should look at having a new non-virtual public method on Workspace and forward to this API.
 - @jasonmalinowski will look at this fix.

SyntaxFactory.AnonymousMethodExpression
 - Added overload with multiple parameters.
 - Part of https://github.com/dotnet/roslyn/pull/37674, which brings the API in line with MethodBodySyntax.
   This change is fine.

Formatter.OrganizeUsings
 - Should make cancellationtoken optional?
 - Need to followup with framework on what the current guidelines are
 - Make this default for now
 - @jasonmalinowski to follow up.

